#!/bin/sh

# git clone http://pkgs.fedoraproject.org/cgit/cups.git/ $FCDISTRO
export UBCNAME="$(wget http://packages.ubuntu.com/ -q -O- | sed -n '/Browse/,/\/ul/{/<li/h};${x;s/.*"\([^"]*\)\/".*/\1/p}')"

# TODO getoptize

RPMH="$HOME/RPM"
NNAME=`find $RPMH/SPECS -name \*.spec | tail -1`
NAME="${1:-$NNAME}"
# if specfile or no $1 is provided
NAME="${NAME##*/}"; NAME="${NAME%.spec}"
TMDISTRO="${TMDISTRO:-$HOME/others}"
FCDISTRO="${FCDISTRO:-$TMDISTRO/fc}"
UBDISTRO="${UBDISTRO:-$TMDISTRO/debian}"
SRCSPEC=""
DSTSRC="$RPMH/SOURCES"
PATCHLOG="$DSTSRC/README.patches"
DSTSPEC="$DSTSRC/$NAME.spec"
DSTBUILD="$RPMH/BUILD/`ls $RPMH/BUILD/ | tail -1`"
FCID="FC"
UBID="Ubuntu"
# This files can set up UNUSED_FC, FAILED_FC, UNUSED_UB and FAILED_UB"
UNUSED_FC=""; FAILED_FC=""; UNUSED_UB=""; FAILED_UB=""
for s in ".sh" ""; do for n in "$0" "`basename $0`"; do
  test -r "${n%$s}.unused" && { echo "Using ${n%$s}.unused"; . "${n%$s}.unused"; } || :
done; done

mkdir -p "$TMDISTRO"
test -d "$FCDISTRO" || git clone http://pkgs.fedoraproject.org/cgit/$NAME.git "$FCDISTRO"
#test -d "$UBDISTRO" || wget -q -O- `wget -q -O- "http://packages.ubuntu.com/$UBCNAME/$NAME" | grep 'debian.tar.[gx]z' | sed 's@.*href="\([^"]*\).*@\1@'` | tar x -C "$TMDISTRO" -f -
test -d "$UBDISTRO" || {
  UBDIFF=`wget -q -O- "http://packages.ubuntu.com/$UBCNAME/$NAME" | grep 'debian.tar.[gx]z' | sed 's@.*href="\([^"]*\).*@\1@'`
  case "$UBDIFF" in
    *gz) UBXDIFF="x";;
    *xz) UBXDIFF="J";;
  esac
  wget -q -O- "$UBDIFF" | tar x$UBXDIFF -C "$TMDISTRO" -f -
}

mkdir -p "$DSTSRC"
for S in $NAME.spec $RPMH/SPECS/$NAME.spec; do
  test -r $S && { SRCSPEC="$S"; break; }
done

delGENpatches() { # e-regexp
  local F="$1" T
  shift
  for T; do
    sed -i -r '/^## '"$T"' /,/^## /{
    /^## '"$T"' /a
    /^[^#]|^[[:space:]]*$|^#+patch/d
    }' "$F"
  done
}

insPatch() { # patchfile patchargs commented distro patchdir
  local a DID="$4" DPD="$5"
  local pn="$DID-${1#$NAME-}"
  pn="${pn%.patch}.patch"
  test "$3" == "" && a="%" || a="$3"

  sed -ri "
  /^## $DID patches/,/^$/{
    /^$/iPatch$NPATCH: $pn
  }" "$DSTSPEC" &&
  sed -ri "
  /^## $DID apply patches/,/^$/{
    /^$/i${a}patch$NPATCH $2
  }" "$DSTSPEC" &&
  cp "$DPD/$1" "$DSTSRC/$pn" &&
  echo "$a $DID $1" >> "$PATCHLOG"
  NPATCH="$(($NPATCH + 1))"
}

chkDebPatches() { # patchdir dir [patch parameters]
  local P="`realpath "$1"`" D="`realpath "$2"`"
  shift; shift
  cd "$D"; pwd
  git init
  git config user.email "you@example.com"
  git config user.name "Your Name"
  git add .
  git commit -a -q -m "INIT" || :
  git tag -d INIT || : > /dev/null 2>&1
  git tag INIT || return 1
  for p in `grep "^[^#].*" "$P/series"`; do
    echo "### $p" >&2
    if patch "$@" < "$P/$p" >&2 ; then
      git add .
      # > /dev/null
      git commit -a -q -m "$p"
      echo "$p"
    else
      git reset -q --hard
      git clean -qfd
      echo "## $p"
    fi
  done
}

chkPatchGone() { # patches where_to_check [name]
  for p in $1; do
    fgrep -q "$p" "$2" || echo "Warning: $p is not fount in ${3:-$2}"
  done
}

cp "$SRCSPEC" "$DSTSPEC"
delGENpatches "$DSTSPEC" "$FCID" "$UBID"
:>"$PATCHLOG"

# FC
rm -f "$DSTSRC/$FCID-"*

# store FC names
#eval `sed -rn 's/^(Patch[[:digit:]]+):[[:space:]]*(.+)/\1="\2";/p' "$FCDISTRO/$NAME.spec"`
eval `sed -rn '/^Patch[[:digit:]]+/{
s/^(Patch[[:digit:]]+):[[:space:]]*(.+)/\1="\2";/
'"s/%name|%\{name\}/$NAME/g"'
p
}
' "$FCDISTRO/$NAME.spec"`

# apply FC patches
NPATCH="1"
egrep '^%patch[[:digit:]]+[[:space:]]' "$FCDISTRO/$NAME.spec" | 
  while read cmd args; do
    n="${cmd#%patch}"
    eval 'f="$Patch'$n'"'; F="${f#$NAME-}"; F="${F%.patch}"
    echo "$UNUSED_FC" | fgrep -q "$F" && unused="#" || unused=""
    insPatch "$f" "$args" "$unused" $FCID "$FCDISTRO"
  done
chkPatchGone "$UNUSED_FC" "$FCDISTRO/$NAME.spec" FC

# TODO apply UB patches
NPATCH="101"
for f in `grep "^[^#].*" "$UBDISTRO/patches/series"`; do
  if echo "$UNUSED_UB" | fgrep -q "$f"; then
    unused="#"
  elif  echo "$FAILED_UB" | fgrep -q "$f"; then
    unused="##"
  else
    unused=""
  fi
  insPatch "$f" "-p1" "$unused" "$UBID" "$UBDISTRO/patches"
done
chkPatchGone "$UNUSED_UB" "$UBDISTRO/patches/series" Ubuntu
#chkDebPatches "$UBDISTRO/patches" "$DSTBUILD" -p 1 2> $HOME/.log.tmp

for ss in ".sh" ""; do for s in ".sh" ""; do for n in "$0" "`basename $0`"; do
  test -r "${n%$s}.after$ss" && { echo "Using ${n%$s}.after$ss"; . "${n%$s}.after$ss"; } || :
done; done; done
